/*
 * isrs.cpp
 *
 *  Created on: Dec 12, 2023
 *      Author: remi.heredero
 */

#include "stm32f7xx_hal.h"
#include "main.h"
#include "board/buttonscontroller.h"
#include "app/factory.h"

uint16_t adcValuesBuffer[ADC_VALUES_BUFFER_SIZE];
int ADCBufferIndex = 0;


extern "C" void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin)
{
      switch (GPIO_Pin)
      {
        case BUTTON0_Pin:
        case BUTTON1_Pin:
        case BUTTON2_Pin:
        case BUTTON3_Pin:
            ButtonsController::getInstance().onIrq();
            break;
        default:
            break;
      }
}

extern "C" void HAL_ADC_ConvCpltCallback(ADC_HandleTypeDef * hadc) {
	//HAL_GPIO_TogglePin(OUT1_GPIO_Port, OUT1_Pin);
	adcValuesBuffer[ADCBufferIndex] = HAL_ADC_GetValue(hadc);
	ADCBufferIndex++;
	if(ADCBufferIndex == ADC_VALUES_BUFFER_SIZE) ADCBufferIndex = 0;
}



